/*
 * ExactSubtreeMatch.cpp
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#include "ExactSubtreeMatch.h"
#include <registration/AlgoRegistration.hpp>

namespace arbology {

namespace exact {

ext::set < unsigned > ExactSubtreeMatch::match ( const tree::Tree & subject, const tree::Tree & pattern ) {
	return dispatch ( subject.getData ( ), pattern.getData ( ) );
}

auto ExactSubtreeMatchUnrankedTree = registration::OverloadRegister < ExactSubtreeMatch, ext::set < unsigned >, tree::UnrankedTree < > > ( ExactSubtreeMatch::match );
auto ExactSubtreeMatchRankedTree = registration::OverloadRegister < ExactSubtreeMatch, ext::set < unsigned >, tree::RankedTree < > > ( ExactSubtreeMatch::match );
auto ExactSubtreeMatchPrefixRankedTree = registration::OverloadRegister < ExactSubtreeMatch, ext::set < unsigned >, tree::PrefixRankedTree < > > ( ExactSubtreeMatch::match );
auto ExactSubtreeMatchPrefixRankedBarTree = registration::OverloadRegister < ExactSubtreeMatch, ext::set < unsigned >, tree::PrefixRankedBarTree < > > ( ExactSubtreeMatch::match );

} /* namespace exact */

} /* namespace arbology */
