/*
 * ToGrammar.cpp
 *
 *  Created on: 9. 2. 2014
 *      Author: Jan Travnicek
 */

#include "ToGrammar.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace convert {

grammar::Grammar ToGrammar::convert(const automaton::Automaton& automaton) {
	return dispatch(automaton.getData());
}

auto ToGrammarNFA = registration::OverloadRegister < ToGrammar, grammar::Grammar, automaton::NFA < > >(ToGrammar::convert);

auto ToGrammarDFA = registration::OverloadRegister < ToGrammar, grammar::Grammar, automaton::DFA < > >(ToGrammar::convert);

} /* namespace convert */

} /* namespace automaton */
