/*
 * RandomizeAutomaton.cpp
 *
 *  Created on: 9. 2. 2017
 *	  Author: Jan Travnicek
 */

#include "RandomizeAutomaton.h"
#include <automaton/Automaton.h>
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace generate {

auto RandomizeAutomatonDFA = registration::OverloadRegister < RandomizeAutomaton, automaton::DFA < >, automaton::DFA < > > ( RandomizeAutomaton::randomize );
auto RandomizeAutomatonMultiInitialStateNFA = registration::OverloadRegister < RandomizeAutomaton, automaton::MultiInitialStateNFA < >, automaton::MultiInitialStateNFA < > > ( RandomizeAutomaton::randomize );
auto RandomizeAutomatonNFA = registration::OverloadRegister < RandomizeAutomaton, automaton::NFA < >, automaton::NFA < > > ( RandomizeAutomaton::randomize );
auto RandomizeAutomatonEpsilonNFA = registration::OverloadRegister < RandomizeAutomaton, automaton::EpsilonNFA < >, automaton::EpsilonNFA < > > ( RandomizeAutomaton::randomize );

automaton::Automaton RandomizeAutomaton::randomize ( const automaton::Automaton & automaton ) {
	return dispatch ( automaton.getData ( ) );
}

} /* namespace generate */

} /* namespace automaton */
