/*
 * Occurrences.cpp
 *
 *  Created on: 9. 2. 2014
 *	  Author: Jan Travnicek
 */

#include "Occurrences.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace run {

ext::set < unsigned > Occurrences::occurrences ( const automaton::Automaton & automaton, const alib::Object & object ) {
	return dispatch ( automaton.getData ( ), object.getData ( ) );
}

ext::set < unsigned > Occurrences::occurrences ( const automaton::Automaton & automaton, const string::LinearString < > & string ) {
	return dispatch ( automaton.getData ( ), string );
}

ext::set < unsigned > Occurrences::occurrences ( const automaton::Automaton & automaton, const tree::RankedTree < > & tree ) {
	return dispatch ( automaton.getData ( ), tree );
}

auto OccurrencesDFALinearString = registration::OverloadRegister < Occurrences, ext::set < unsigned >, automaton::DFA < >, string::LinearString < > > ( Occurrences::occurrences );
auto OccurrencesDFTARankedTree = registration::OverloadRegister < Occurrences, ext::set < unsigned >, automaton::DFTA < >, tree::RankedTree < > > ( Occurrences::occurrences );
auto OccurrencesInputDrivenDPDALinearString = registration::OverloadRegister < Occurrences, ext::set < unsigned >, automaton::InputDrivenDPDA < >, string::LinearString < > > ( Occurrences::occurrences );
auto OccurrencesVisiblyPushdownDPDALinearString = registration::OverloadRegister < Occurrences, ext::set < unsigned >, automaton::VisiblyPushdownDPDA < >, string::LinearString < > > ( Occurrences::occurrences );
auto OccurrencesRealTimeHeightDeterministicDPDALinearString = registration::OverloadRegister < Occurrences, ext::set < unsigned >, automaton::RealTimeHeightDeterministicDPDA < >, string::LinearString < > > ( Occurrences::occurrences );
auto OccurrencesDPDALinearString = registration::OverloadRegister < Occurrences, ext::set < unsigned >, automaton::DPDA < >, string::LinearString < > > ( Occurrences::occurrences );

} /* namespace run */

} /* namespace automaton */
