/*
 * Result.cpp
 *
 *  Created on: 9. 2. 2014
 *	  Author: Jan Travnicek
 */

#include "Result.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace run {

DefaultStateType Result::result ( const automaton::Automaton & automaton, const alib::Object & object, const DefaultStateType & failLabel ) {
	return dispatch ( automaton.getData ( ), object.getData ( ), failLabel );
}

auto ResultDFALinearString = registration::OverloadRegister < Result, DefaultStateType, automaton::DFA < >, string::LinearString < > > ( Result::result );
auto ResultDFTARankedTree = registration::OverloadRegister < Result, DefaultStateType, automaton::DFTA < >, tree::RankedTree < > > ( Result::result );
auto ResultInputDrivenDPDALinearString = registration::OverloadRegister < Result, DefaultStateType, automaton::InputDrivenDPDA < >, string::LinearString < > > ( Result::result );
auto ResultVisiblyPushdownDPDALinearString = registration::OverloadRegister < Result, DefaultStateType, automaton::VisiblyPushdownDPDA < >, string::LinearString < > > ( Result::result );
auto ResultRealTimeHeightDeterministicDPDALinearString = registration::OverloadRegister < Result, DefaultStateType, automaton::RealTimeHeightDeterministicDPDA < >, string::LinearString < > > ( Result::result );
auto ResultDPDALinearString = registration::OverloadRegister < Result, DefaultStateType, automaton::DPDA < >, string::LinearString < > > ( Result::result );

} /* namespace run */

} /* namespace automaton */
