/*
 * Translate.cpp
 *
 *  Created on: 12. 5. 2016
 *      Author: Jakub Doupal
 */

#include "Translate.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace run {

ext::set < string::LinearString < > > Translate::translate ( const automaton::Automaton & automaton, const alib::Object & object ) {
	return dispatch ( automaton.getData ( ), object.getData ( ) );
}

ext::set < string::LinearString < > > Translate::translate ( const automaton::Automaton & automaton, const string::LinearString < > & string ) {
	return dispatch ( automaton.getData ( ), string );
}

auto TranslateNPDTALinearString = registration::OverloadRegister < Translate, ext::set < string::LinearString < > >, automaton::NPDTA < >, string::LinearString < > > ( Translate::translate );

} /* namespace run */

} /* namespace automaton */
