/*
 * EpsilonRemoverIncoming.cpp
 *
 *  Created on: 24. 11. 2014
 *	  Author: Jan Travnicek
 */

#include "EpsilonRemoverIncoming.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

auto EpsilonRemoverIncomingDFA = registration::OverloadRegister < EpsilonRemoverIncoming, automaton::DFA < >, automaton::DFA < > > ( EpsilonRemoverIncoming::remove );
auto EpsilonRemoverIncomingMultiInitialStateNFA = registration::OverloadRegister < EpsilonRemoverIncoming, automaton::MultiInitialStateNFA < > , automaton::MultiInitialStateNFA < > > ( EpsilonRemoverIncoming::remove );
auto EpsilonRemoverIncomingNFA = registration::OverloadRegister < EpsilonRemoverIncoming, automaton::NFA < > , automaton::NFA < > > ( EpsilonRemoverIncoming::remove );
auto EpsilonRemoverIncomingEpsilonNFA = registration::OverloadRegister < EpsilonRemoverIncoming, automaton::NFA < > , automaton::EpsilonNFA < > > ( EpsilonRemoverIncoming::remove );

auto EpsilonRemoverIncomingDFA2 = registration::AbstractRegister < EpsilonRemoverIncoming, automaton::DFA < >, const automaton::DFA < > & > ( EpsilonRemoverIncoming::remove );
auto EpsilonRemoverIncomingMultiInitialStateNFA2 = registration::AbstractRegister < EpsilonRemoverIncoming, automaton::MultiInitialStateNFA < > , const automaton::MultiInitialStateNFA < > & > ( EpsilonRemoverIncoming::remove );
auto EpsilonRemoverIncomingNFA2 = registration::AbstractRegister < EpsilonRemoverIncoming, automaton::NFA < > , const automaton::NFA < > & > ( EpsilonRemoverIncoming::remove );
auto EpsilonRemoverIncomingEpsilonNFA2 = registration::AbstractRegister < EpsilonRemoverIncoming, automaton::NFA < > , const automaton::EpsilonNFA < > & > ( EpsilonRemoverIncoming::remove );

automaton::Automaton EpsilonRemoverIncoming::remove(const automaton::Automaton& automaton) {
	return dispatch(automaton.getData());
}

} /* namespace simplify */

} /* namespace automaton */
