/*
 * EpsilonRemoverOutgoing.cpp
 *
 *  Created on: 16. 1. 2014
 *	  Author: Tomas Pecka
 */

#include "EpsilonRemoverOutgoing.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

auto EpsilonRemoverOutgoingDFA = registration::OverloadRegister < EpsilonRemoverOutgoing, automaton::DFA < >, automaton::DFA < > > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingMultiInitialStateNFA = registration::OverloadRegister < EpsilonRemoverOutgoing, automaton::MultiInitialStateNFA < > , automaton::MultiInitialStateNFA < > > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingNFA = registration::OverloadRegister < EpsilonRemoverOutgoing, automaton::NFA < >, automaton::NFA < > > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingEpsilonNFA = registration::OverloadRegister < EpsilonRemoverOutgoing, automaton::MultiInitialStateNFA < >, automaton::EpsilonNFA < > > ( EpsilonRemoverOutgoing::remove );

auto EpsilonRemoverOutgoingDFA2 = registration::AbstractRegister < EpsilonRemoverOutgoing, automaton::DFA < >, const automaton::DFA < > & > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingMultiInitialStateNFA2 = registration::AbstractRegister < EpsilonRemoverOutgoing, automaton::MultiInitialStateNFA < > , const automaton::MultiInitialStateNFA < > & > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingNFA2 = registration::AbstractRegister < EpsilonRemoverOutgoing, automaton::NFA < >, const automaton::NFA < > & > ( EpsilonRemoverOutgoing::remove );
auto EpsilonRemoverOutgoingEpsilonNFA2 = registration::AbstractRegister < EpsilonRemoverOutgoing, automaton::MultiInitialStateNFA < >, const automaton::EpsilonNFA < > & > ( EpsilonRemoverOutgoing::remove );

automaton::Automaton EpsilonRemoverOutgoing::remove(const automaton::Automaton& automaton) {
	return dispatch(automaton.getData());
}

} /* namespace simplify */

} /* namespace automaton */
