/*
 * MinimizeBrzozowski.cpp
 *
 *  Created on: 18. 11. 2014
 *	  Author: Tomas Pecka
 */

#include "MinimizeBrzozowski.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

automaton::Automaton MinimizeBrzozowski::minimize(const automaton::Automaton& automaton) {
	automaton::Automaton res = dispatch(automaton.getData());
	res.normalize ( );
	return res;
}

auto MinimizeBrzozowskiDFA = registration::OverloadRegister < MinimizeBrzozowski, automaton::DFA < DefaultSymbolType, ext::set < ext::set < DefaultStateType > > >, automaton::DFA < > > ( MinimizeBrzozowski::minimize );
auto MinimizeBrzozowskiNFA = registration::OverloadRegister < MinimizeBrzozowski, automaton::DFA < DefaultSymbolType, ext::set < ext::set < DefaultStateType > > >, automaton::NFA < > > ( MinimizeBrzozowski::minimize );

auto MinimizeBrzozowskiDFA2 = registration::AbstractRegister < MinimizeBrzozowski, automaton::DFA < DefaultSymbolType, ext::set < ext::set < DefaultStateType > > >, const automaton::DFA < > & > ( MinimizeBrzozowski::minimize );
auto MinimizeBrzozowskiNFA2 = registration::AbstractRegister < MinimizeBrzozowski, automaton::DFA < DefaultSymbolType, ext::set < ext::set < DefaultStateType > > >, const automaton::NFA < > & > ( MinimizeBrzozowski::minimize );

} /* namespace simplify */

} /* namespace automaton */
