/*
 * Total.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Tomas Pecka
 */

#include "Total.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

automaton::Automaton Total::total(const Automaton& automaton) {
	return dispatch(automaton.getData());
}

auto TotalNFA = registration::OverloadRegister < Total, automaton::NFA < >, automaton::NFA < > > ( Total::total );
auto TotalDFA = registration::OverloadRegister < Total, automaton::DFA < >, automaton::DFA < > > ( Total::total );

auto TotalNFA2 = registration::AbstractRegister < Total, automaton::NFA < >, const automaton::NFA < > & > ( Total::total );
auto TotalDFA2 = registration::AbstractRegister < Total, automaton::DFA < >, const automaton::DFA < > & > ( Total::total );

} /* namespace simplify */

} /* namespace automaton */

