/*
 * AutomataUnionCartesianProduct.cpp
 *
 *  Created on: 20. 11. 2014
 *	  Author: Tomas Pecka
 */

#include "AutomataUnionCartesianProduct.h"
#include <exception/CommonException.h>
#include <common/DefaultStatesPairType.h>
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace transform {

automaton::Automaton AutomataUnionCartesianProduct::unification(const automaton::Automaton& first, const automaton::Automaton& second) {
	automaton::Automaton res = dispatch(first.getData(), second.getData());
	res.normalize ( );
	return res;
}

auto AutomataUnionCartesianProductDFA = registration::OverloadRegister < AutomataUnionCartesianProduct, automaton::DFA < DefaultSymbolType, ext::pair < DefaultStateType, DefaultStateType > >, automaton::DFA < > > ( AutomataUnionCartesianProduct::unification );
auto AutomataUnionCartesianProductNFA = registration::OverloadRegister < AutomataUnionCartesianProduct, automaton::NFA < DefaultSymbolType, ext::pair < DefaultStateType, DefaultStateType > >, automaton::NFA < > > ( AutomataUnionCartesianProduct::unification );

auto AutomataUnionCartesianProductDFA2 = registration::AbstractRegister < AutomataUnionCartesianProduct, automaton::DFA < DefaultSymbolType, ext::pair < DefaultStateType, DefaultStateType > >, const automaton::DFA < > &, const automaton::DFA < > & > ( AutomataUnionCartesianProduct::unification );
auto AutomataUnionCartesianProductNFA2 = registration::AbstractRegister < AutomataUnionCartesianProduct, automaton::NFA < DefaultSymbolType, ext::pair < DefaultStateType, DefaultStateType > >, const automaton::NFA < > &, const automaton::NFA < > & > ( AutomataUnionCartesianProduct::unification );

} /* namespace transform */

} /* namespace automaton */
