/*
 * ToRegExpAlgebraic.cpp
 *
 *  Created on: 4. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "ToRegExpAlgebraic.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace convert {

regexp::RegExp ToRegExpAlgebraic::convert(const grammar::Grammar& grammar) {
	return dispatch(grammar.getData());
}

auto ToRegExpAlgebraicLeftRG = registration::OverloadRegister < ToRegExpAlgebraic, regexp::UnboundedRegExp < >, grammar::LeftRG < > > ( ToRegExpAlgebraic::convert );
auto ToRegExpAlgebraicRightRG = registration::OverloadRegister < ToRegExpAlgebraic, regexp::UnboundedRegExp < >, grammar::RightRG < > > ( ToRegExpAlgebraic::convert );

} /* namespace convert */

} /* namespace grammar */
