/*
 * GenerateUpToLength.cpp
 *
 *  Created on: 22. 3. 2014
 *	  Author: Jan Travnicek
 */

#include "GenerateUpToLength.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace generate {

auto GenerateUpToLengthEpsilonFreeCFG = registration::OverloadRegister < GenerateUpToLength, ext::set < string::LinearString < > >, grammar::EpsilonFreeCFG < > > ( GenerateUpToLength::generate );
auto GenerateUpToLengthGNF = registration::OverloadRegister < GenerateUpToLength, ext::set < string::LinearString < > >, grammar::GNF < > > ( GenerateUpToLength::generate );
auto GenerateUpToLengthCNF = registration::OverloadRegister < GenerateUpToLength, ext::set < string::LinearString < > >, grammar::CNF < > > ( GenerateUpToLength::generate );
auto GenerateUpToLengthLeftRG = registration::OverloadRegister < GenerateUpToLength, ext::set < string::LinearString < > >, grammar::LeftRG < > > ( GenerateUpToLength::generate );
auto GenerateUpToLengthRightRG = registration::OverloadRegister < GenerateUpToLength, ext::set < string::LinearString < > >, grammar::RightRG < > > ( GenerateUpToLength::generate );

ext::set<string::LinearString < >> GenerateUpToLength::generate(const grammar::Grammar& grammar, unsigned length) {
	return dispatch(grammar.getData(), length);
}

} /* namespace generate */

} /* namespace grammar */

