/*
 * NullableNonterminals.cpp
 *
 *  Created on: 22. 3. 2014
 *	  Author: Tomas Pecka
 */

#include "NullableNonterminals.h"
#include <registration/AlgoRegistration.hpp>

namespace grammar {

namespace properties {

auto NullableNonterminalsCFG = registration::OverloadRegister < NullableNonterminals, ext::set < DefaultSymbolType >, grammar::CFG < > > ( NullableNonterminals::getNullableNonterminals );
auto NullableNonterminalsEpsilonFreeCFG = registration::OverloadRegister < NullableNonterminals, ext::set < DefaultSymbolType >, grammar::EpsilonFreeCFG < > > ( NullableNonterminals::getNullableNonterminals );
auto NullableNonterminalsGNF = registration::OverloadRegister < NullableNonterminals, ext::set < DefaultSymbolType >, grammar::GNF < > > ( NullableNonterminals::getNullableNonterminals );
auto NullableNonterminalsCNF = registration::OverloadRegister < NullableNonterminals, ext::set < DefaultSymbolType >, grammar::CNF < > > ( NullableNonterminals::getNullableNonterminals );
auto NullableNonterminalsLG = registration::OverloadRegister < NullableNonterminals, ext::set < DefaultSymbolType >, grammar::LG < > > ( NullableNonterminals::getNullableNonterminals );
auto NullableNonterminalsLeftLG = registration::OverloadRegister < NullableNonterminals, ext::set < DefaultSymbolType >, grammar::LeftLG < > > ( NullableNonterminals::getNullableNonterminals );
auto NullableNonterminalsLeftRG = registration::OverloadRegister < NullableNonterminals, ext::set < DefaultSymbolType >, grammar::LeftRG < > > ( NullableNonterminals::getNullableNonterminals );
auto NullableNonterminalsRightLG = registration::OverloadRegister < NullableNonterminals, ext::set < DefaultSymbolType >, grammar::RightLG < > > ( NullableNonterminals::getNullableNonterminals );
auto NullableNonterminalsRightRG = registration::OverloadRegister < NullableNonterminals, ext::set < DefaultSymbolType >, grammar::RightRG < > > ( NullableNonterminals::getNullableNonterminals );

ext::set<DefaultSymbolType> NullableNonterminals::getNullableNonterminals(const grammar::Grammar& grammar ) {
	return dispatch(grammar.getData());
}

} /* namespace properties */

} /* namespace grammar */
