/*
 * RegExpDerivation.cpp
 *
 *  Created on: 19. 1. 2014
 *	  Author: Tomas Pecka
 */

#include "RegExpDerivation.h"
#include <registration/AlgoRegistration.hpp>

namespace regexp {

regexp::RegExp RegExpDerivation::derivation(const regexp::RegExp& regexp, const string::LinearString < >& string) {
	return dispatch(regexp.getData(), string);
}

auto RegExpDerivationFormalRegExp = registration::OverloadRegister < RegExpDerivation, regexp::FormalRegExp < >, regexp::FormalRegExp < > > ( RegExpDerivation::derivation );
auto RegExpDerivationUnboundedRegExp = registration::OverloadRegister < RegExpDerivation, regexp::UnboundedRegExp < >, regexp::UnboundedRegExp < > > ( RegExpDerivation::derivation );

} /* namespace regexp */
