/*
 * RegExpIterate.cpp
 *
 *  Created on: 17. 10. 2014
 *	  Author: Jan Travnicek
 */

#include "RegExpIterate.h"
#include <registration/AlgoRegistration.hpp>

namespace regexp {

regexp::RegExp RegExpIterate::iterate(const regexp::RegExp& regexp) {
	return dispatch(regexp.getData());
}

auto RegExpIterateFormalRegExpFormalRegExp = registration::OverloadRegister < RegExpIterate, regexp::FormalRegExp < >, regexp::FormalRegExp < > > ( RegExpIterate::iterate );
auto RegExpIterateUnboundedRegExpUnboundedRegExp = registration::OverloadRegister < RegExpIterate, regexp::UnboundedRegExp < >, regexp::UnboundedRegExp < > > ( RegExpIterate::iterate );

} /* namespace regexp */
