/*
 * ToPostfixPushdownAutomaton.h
 *
 *  Created on: 11. 4. 2016
 *	  Author: Tomas Pecka
 */

#ifndef RTE_TO_AUTOMATON_H_
#define RTE_TO_AUTOMATON_H_

#include <core/multipleDispatch.hpp>

#include <rte/RTE.h>
#include <rte/formal/FormalRTE.h>

#include <automaton/Automaton.h>

namespace rte {

namespace convert {

class ToPostfixPushdownAutomaton : public alib::SingleDispatch < ToPostfixPushdownAutomaton, automaton::Automaton, const rte::RTEBase & > {
public:
	/**
	 * Performs conversion.
	 * @return PDA equivalent to original regular rte expression reading linearized postfix tree
	 */
	static automaton::Automaton convert ( const rte::RTE & rte );

	static automaton::Automaton convert ( const rte::FormalRTE < > & rte );

};

} /* namespace convert */

} /* namespace rte */

#endif /* RTE_TO_AUTOMATON_H_ */
