/*
 * ExactEqual.cpp
 *
 *  Created on: Oct 9, 2014
 *	  Author: Radomir Polach */

#include "ExactEqual.h"

#include "string/LinearString.h"
#include "string/CyclicString.h"
#include "string/Epsilon.h"
#include <registration/AlgoRegistration.hpp>

namespace string {

namespace naive {

bool ExactEqual::equals ( const string::String & u, const string::String & v ) {
	return dispatch ( u.getData ( ), v.getData ( ) );
}

auto ExactEqualEpsilon = registration::OverloadRegister < ExactEqual, bool, string::Epsilon < > > ( ExactEqual::equals );
auto ExactEqualLinearString = registration::OverloadRegister < ExactEqual, bool, string::LinearString < > > ( ExactEqual::equals );
auto ExactEqualCyclicString = registration::OverloadRegister < ExactEqual, bool, string::CyclicString < > > ( ExactEqual::equals );

} /* namespace naive */

} /* namespace string */
