/*
 * BoyerMoore.cpp
 *
 *  Created on: 23. 3. 2017
 *      Author: Jan Travnicek
 */

#include "BoyerMoore.h"
#include <registration/AlgoRegistration.hpp>

namespace stringology {

namespace exact {

ext::set<unsigned> BoyerMoore::match(const string::String& subject, const string::String& pattern) {
	return dispatch(subject.getData(), pattern.getData());
}

auto BoyerMooreLinearStringLinearString = registration::OverloadRegister < BoyerMoore, ext::set < unsigned >, string::LinearString < >, string::LinearString < > > ( BoyerMoore::match );

} /* namespace exact */

} /* namespace stringology */
