/*
 * PositionHeapFactors.cpp
 *
 *  Created on: 2. 1. 2017
 *      Author: Jan Travnicek
 */

#include "PositionHeapFactors.h"

#include <string/LinearString.h>
#include <registration/AlgoRegistration.hpp>

namespace stringology {

namespace query {

ext::set < unsigned > PositionHeapFactors::query ( const indexes::stringology::PositionHeap < DefaultSymbolType > & positionHeap, const string::String & string ) {
	return dispatch ( positionHeap, string.getData ( ) );
}

auto PositionHeapFactorsLinearString = registration::OverloadRegister < PositionHeapFactors, ext::set < unsigned >, string::LinearString < > > ( PositionHeapFactors::query );

} /* namespace query */

} /* namespace stringology */
