/*
 * SuffixArrayFactors.cpp
 *
 *  Created on: 10. 1. 2017
 *      Author: Jan Travnicek
 */

#include "SuffixArrayFactors.h"

#include <string/LinearString.h>
#include <registration/AlgoRegistration.hpp>

namespace stringology {

namespace query {

ext::set < unsigned > SuffixArrayFactors::query ( const indexes::stringology::SuffixArray < > & suffixArray, const string::String & string ) {
	return dispatch ( suffixArray, string.getData ( ) );
}

auto SuffixArrayFactorsLinearString = registration::OverloadRegister < SuffixArrayFactors, ext::set < unsigned >, string::LinearString < > > ( SuffixArrayFactors::query );

} /* namespace query */

} /* namespace stringology */
