/*
 * SuffixTrieFactors.cpp
 *
 *  Created on: 2. 1. 2017
 *      Author: Jan Travnicek
 */

#include "SuffixTrieFactors.h"

#include <string/LinearString.h>
#include <registration/AlgoRegistration.hpp>

namespace stringology {

namespace query {

ext::set < unsigned > SuffixTrieFactors::query ( const indexes::stringology::SuffixTrie < DefaultSymbolType > & suffixTrie, const string::String & string ) {
	return dispatch ( suffixTrie, string.getData ( ) );
}

auto SuffixTrieFactorsLinearString = registration::OverloadRegister < SuffixTrieFactors, ext::set < unsigned >, string::LinearString < > > ( SuffixTrieFactors::query );

} /* namespace query */

} /* namespace stringology */
