/*
 * ExactSubtreeRepeatsNaive.cpp
 *
 *  Created on: 1. 4. 2016
 *      Author: Jan Travnicek
 */

#include "ExactSubtreeRepeatsNaive.h"
#include <tree/Tree.h>
#include <registration/AlgoRegistration.hpp>

namespace tree {

namespace properties {

tree::Tree ExactSubtreeRepeatsNaive::repeats ( const tree::Tree & tree ) {
	return dispatch ( tree.getData ( ) );
}

auto ExactRepeatsNaiveRankedTree = registration::OverloadRegister < ExactSubtreeRepeatsNaive, tree::RankedTree < unsigned, DefaultRankType >, tree::RankedTree < > > ( ExactSubtreeRepeatsNaive::repeats );
auto ExactRepeatsNaivePrefixRankedTree = registration::OverloadRegister < ExactSubtreeRepeatsNaive, tree::PrefixRankedTree < unsigned, DefaultRankType >, tree::PrefixRankedTree < > > ( ExactSubtreeRepeatsNaive::repeats );
auto ExactRepeatsNaivePostfixRankedTree = registration::OverloadRegister < ExactSubtreeRepeatsNaive, tree::PostfixRankedTree < unsigned, DefaultRankType >, tree::PostfixRankedTree < > > ( ExactSubtreeRepeatsNaive::repeats );
auto ExactRepeatsNaivePrefixRankedBarTree = registration::OverloadRegister < ExactSubtreeRepeatsNaive, tree::PrefixRankedBarTree < unsigned, DefaultRankType >, tree::PrefixRankedBarTree < > > ( ExactSubtreeRepeatsNaive::repeats );

} /* namespace properties */

} /* namespace tree */
