#include "RegExpEmptyTest.h"

#include "regexp/properties/RegExpEmpty.h"

#include <regexp/RegExp.h>

#include <factory/StringDataFactory.hpp>

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( RegExpEmptyTest, "regexp" );
CPPUNIT_TEST_SUITE_REGISTRATION( RegExpEmptyTest );

void RegExpEmptyTest::setUp() {
}

void RegExpEmptyTest::tearDown() {
}

void RegExpEmptyTest::testRegExpEmpty() {
	{
		std::string input = "(#E #0 ) + ( #0 a + (b ( #0 (a*) ) ) )";
		regexp::RegExp re = alib::StringDataFactory::fromString (input);

		CPPUNIT_ASSERT(regexp::properties::RegExpEmpty::languageIsEmpty(re));
	}
	{
		std::string input = "(#E + a ) + ( #0 a + (b ( #0 (a*) ) ) )";
		regexp::RegExp re = alib::StringDataFactory::fromString (input);

		CPPUNIT_ASSERT(! regexp::properties::RegExpEmpty::languageIsEmpty(re));
	}
}
