/*
 * PairSetAccess.cpp
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#include "PairSetAccess.h"

#include <factory/XmlDataFactory.hpp>
#include <container/ObjectsSet.h>
#include <container/ObjectsMap.h>
#include <container/ObjectsTuple.h>
#include <container/ObjectsVector.h>
#include <container/ObjectsVariant.h>
#include <container/ObjectsPair.h>
#include <container/ObjectsTree.h>

namespace dataAccess {

void PairSetAccess::access ( const ext::set < ext::pair < alib::Object, alib::Object > > & pairSet, const PairSetSettings::Settings & settings, const OperationSettings::Settings & operation ) {
	if ( settings == PairSetSettings::Settings::FIRST && operation == OperationSettings::Settings::GET ) {
		ext::set < alib::Object > res;
		for ( const ext::pair < alib::Object, alib::Object > & pair : pairSet )
			res.insert ( pair.first );

		return alib::XmlDataFactory::toStdout ( res );
	}

	if ( settings == PairSetSettings::Settings::SECOND && operation == OperationSettings::Settings::GET ) {
		ext::set < alib::Object > res;
		for ( const ext::pair < alib::Object, alib::Object > & pair : pairSet )
			res.insert ( pair.second );

		return alib::XmlDataFactory::toStdout ( res );
	}

	throw exception::CommonException ( "Component not available" );
}

} /* namespace dataAccess */
