/*
 * TreeAccess.h
 *
 *  Created on: 20. 9. 2014
 *	  Author: Jan Travnicek
 */

#ifndef TREE_ACCESS_H_
#define TREE_ACCESS_H_

#include <core/multipleDispatch.hpp>

#include "tree/Tree.h"
#include "tree/TreeFeatures.h"

#include "settings/TreeSettings.h"
#include "settings/OperationSettings.h"
#include <set>

namespace dataAccess {

class TreeAccess : public alib::SingleDispatch < TreeAccess, void, tree::TreeBase &, const TreeSettings::Settings &, const OperationSettings::Settings &, ext::deque < sax::Token > & > {
public:
	static void access ( tree::Tree & tree, const TreeSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );

	static void access ( tree::RankedTree < > & tree, const TreeSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
	static void access ( tree::RankedPattern < > & tree, const TreeSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
	static void access ( tree::RankedNonlinearPattern < > & tree, const TreeSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
	static void access ( tree::UnrankedTree < > & tree, const TreeSettings::Settings & settings, const OperationSettings::Settings & operation, ext::deque < sax::Token > & argument );
};

} /* namespace dataAccess */

#endif /* TREE_ACCESS_H_ */
