/*
 * ExceptionSettings.h
 *
 *  Created on: 10. 7. 2016
 *	  Author: Jan Travnicek
 */

#ifndef __EXCEPTION_SETTINGS_H__
#define __EXCEPTION_SETTINGS_H__

#include "SettingsHelper.h"

namespace dataAccess {

class ExceptionEnum {
public:
	enum class Settings {
		CAUSE, BACKTRACE, COMMAND, __MAX__
	};

	static std::string toString ( ExceptionEnum::Settings settings ) {
		switch ( settings ) {
		case ExceptionEnum::Settings::CAUSE:
			return "cause";

		case ExceptionEnum::Settings::BACKTRACE:
			return "backtrace";

		case ExceptionEnum::Settings::COMMAND:
			return "command";

		case ExceptionEnum::Settings::__MAX__:
			throw exception::CommonException ( "Invalid enumeration" );
		}
		throw exception::CommonException ( "Invalid enumeration" );
	}

};

class ExceptionSettings : public ExceptionEnum, public EnumClassHelper < ExceptionEnum > {
};

} /* namespace dataAccess */

#endif /* __EXCEPTION_SETTINGS_H__ */
