/*
 * AutomatonDiff.cpp
 *
 *  Created on: Apr 1, 2013
 *      Author: martin
 */

#include "AutomatonDiff.h"
#include <registration/AlgoRegistration.hpp>

namespace compare {

auto AutomatonDiffDFA = registration::OverloadRegister < AutomatonDiff, int, automaton::DFA < >, automaton::DFA < > > ( AutomatonDiff::diff );
auto AutomatonDiffNFA = registration::OverloadRegister < AutomatonDiff, int, automaton::NFA < > , automaton::NFA < > > ( AutomatonDiff::diff );
auto AutomatonDiffMultiInitialStateNFA = registration::OverloadRegister < AutomatonDiff, int, automaton::MultiInitialStateNFA < >, automaton::MultiInitialStateNFA < > > ( AutomatonDiff::diff );
auto AutomatonDiffEpsilonNFA = registration::OverloadRegister < AutomatonDiff, int, automaton::EpsilonNFA < >, automaton::EpsilonNFA < > > ( AutomatonDiff::diff );
auto AutomatonDiffExtendedNFA = registration::OverloadRegister < AutomatonDiff, int, automaton::ExtendedNFA < >, automaton::ExtendedNFA < > > ( AutomatonDiff::diff );
auto AutomatonDiffCompactNFA = registration::OverloadRegister < AutomatonDiff, int, automaton::CompactNFA < >, automaton::CompactNFA < > > ( AutomatonDiff::diff );

auto AutomatonDiffDFTA = registration::OverloadRegister < AutomatonDiff, int, automaton::DFTA < >, automaton::DFTA < > > ( AutomatonDiff::diff );
auto AutomatonDiffNFTA = registration::OverloadRegister < AutomatonDiff, int, automaton::NFTA < >, automaton::NFTA < > > ( AutomatonDiff::diff );

auto AutomatonDiffDPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::DPDA < >, automaton::DPDA < > > ( AutomatonDiff::diff );
auto AutomatonDiffNPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::NPDA < >, automaton::NPDA < > > ( AutomatonDiff::diff );
auto AutomatonDiffInputDrivenDPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::InputDrivenDPDA < >, automaton::InputDrivenDPDA < > > ( AutomatonDiff::diff );
auto AutomatonDiffInputDrivenNPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::InputDrivenNPDA < >, automaton::InputDrivenNPDA < > > ( AutomatonDiff::diff );
auto AutomatonDiffVisiblyPushdownDPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::VisiblyPushdownDPDA < >, automaton::VisiblyPushdownDPDA < > > ( AutomatonDiff::diff );
auto AutomatonDiffVisiblyPushdownNPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::VisiblyPushdownNPDA < >, automaton::VisiblyPushdownNPDA < > > ( AutomatonDiff::diff );
auto AutomatonDiffRealTimeHeightDeterministicDPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::RealTimeHeightDeterministicDPDA < >, automaton::RealTimeHeightDeterministicDPDA < > > ( AutomatonDiff::diff );
auto AutomatonDiffRealTimeHeightDeterministicNPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::RealTimeHeightDeterministicNPDA < >, automaton::RealTimeHeightDeterministicNPDA < > > ( AutomatonDiff::diff );
auto AutomatonDiffSinglePopDPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::SinglePopDPDA < >, automaton::SinglePopDPDA < > > ( AutomatonDiff::diff );
auto AutomatonDiffSinglePopNPDA = registration::OverloadRegister < AutomatonDiff, int, automaton::SinglePopNPDA < >, automaton::SinglePopNPDA < > > ( AutomatonDiff::diff );

auto AutomatonDiffOneTapeDTM = registration::OverloadRegister < AutomatonDiff, int, automaton::OneTapeDTM < >, automaton::OneTapeDTM < > > ( AutomatonDiff::diff );

int AutomatonDiff::diff(const automaton::Automaton& a, const automaton::Automaton& b, std::ostream & out ) {
	return dispatch(a.getData(), b.getData(), out);
}

} /* namespace compare */
