/*
 * GrammarCompare.cpp
 *
 *  Created on: Apr 1, 2013
 *      Author: honza
 */

#include "GrammarCompare.h"
#include <registration/AlgoRegistration.hpp>

namespace compare {

auto GrammarCompareLeftLG = registration::OverloadRegister < GrammarCompare, bool, grammar::LeftLG < >, grammar::LeftLG < > > ( GrammarCompare::compare );
auto GrammarCompareLeftRG = registration::OverloadRegister < GrammarCompare, bool, grammar::LeftRG < >, grammar::LeftRG < > > ( GrammarCompare::compare );
auto GrammarCompareRightLG = registration::OverloadRegister < GrammarCompare, bool, grammar::RightLG < >, grammar::RightLG < > > ( GrammarCompare::compare );
auto GrammarCompareRightRG = registration::OverloadRegister < GrammarCompare, bool, grammar::RightRG < >, grammar::RightRG < > > ( GrammarCompare::compare );

auto GrammarCompareLG = registration::OverloadRegister < GrammarCompare, bool, grammar::LG < >, grammar::LG < > > ( GrammarCompare::compare );
auto GrammarCompareCFG = registration::OverloadRegister < GrammarCompare, bool, grammar::CFG < >, grammar::CFG < > > ( GrammarCompare::compare );
auto GrammarCompareEpsilonFreeCFG = registration::OverloadRegister < GrammarCompare, bool, grammar::EpsilonFreeCFG < >, grammar::EpsilonFreeCFG < > > ( GrammarCompare::compare );
auto GrammarCompareCNF = registration::OverloadRegister < GrammarCompare, bool, grammar::CNF < >, grammar::CNF < > > ( GrammarCompare::compare );
auto GrammarCompareGNF = registration::OverloadRegister < GrammarCompare, bool, grammar::GNF < >, grammar::GNF < > > ( GrammarCompare::compare );
auto GrammarCompareCSG = registration::OverloadRegister < GrammarCompare, bool, grammar::CSG < >, grammar::CSG < > > ( GrammarCompare::compare );

auto GrammarCompareNonContractingGrammar = registration::OverloadRegister < GrammarCompare, bool, grammar::NonContractingGrammar < >, grammar::NonContractingGrammar < > > ( GrammarCompare::compare );
auto GrammarCompareContextPreservingUnrestrictedGrammar = registration::OverloadRegister < GrammarCompare, bool, grammar::ContextPreservingUnrestrictedGrammar < >, grammar::ContextPreservingUnrestrictedGrammar < > > ( GrammarCompare::compare );

auto GrammarCompareUnrestrictedGrammar = registration::OverloadRegister < GrammarCompare, bool, grammar::UnrestrictedGrammar < >, grammar::UnrestrictedGrammar < > > ( GrammarCompare::compare );

bool GrammarCompare::compare(const grammar::Grammar& a, const grammar::Grammar& b ) {
	return dispatch(a.getData(), b.getData() );
}

} /* namespace compare */
