/*
 * StringCompare.cpp
 *
 *  Created on: Apr 4, 2017
 *      Author: Tomas Pecka
 */

#include "StringCompare.h"
#include <registration/AlgoRegistration.hpp>

namespace compare {

auto StringCompareLinear = registration::OverloadRegister < StringCompare, bool, string::LinearString < >, string::LinearString < > > ( StringCompare::compare );
auto StringCompareCyclic = registration::OverloadRegister < StringCompare, bool, string::CyclicString < >, string::CyclicString < > > ( StringCompare::compare );

bool StringCompare::compare ( const string::String & a, const string::String & b ) {
	return dispatch ( a.getData ( ), b.getData ( ) );
}

} /* namespace compare */
