#ifndef _CAST_HELPER_H_
#define _CAST_HELPER_H_

#include <abstraction/Registry.h>

namespace cli {

class CastHelper {
public:
	static std::shared_ptr < abstraction::OperationAbstraction > castHelper ( const std::shared_ptr < abstraction::OperationAbstraction > & param, const std::string & type, bool move ) {
		if ( abstraction::Registry::isCastNoOp ( type, param->getReturnType ( ) ) ) {
			return param;
		}

		bool normalize;

		std::shared_ptr < abstraction::OperationAbstraction > res = abstraction::Registry::getCastAbstraction ( type, param->getReturnType ( ), normalize );
		if ( ! res->attachInput ( param, 0, move ) )
			throw exception::CommonException ( "Can't connect param at 0 of cast to " + type + " with result of type " + param->getReturnType ( ) + "." );
		if ( ! res->eval ( ) )
			throw exception::CommonException ( "Eval of cast to " + type + " failed." );

		if ( normalize ) {
			std::shared_ptr < abstraction::OperationAbstraction > normalized = abstraction::Registry::getNormalizeAbstraction ( res->getReturnType ( ) );
			if ( ! normalized->attachInput ( res, 0, true ) )
				throw exception::CommonException ( "Can't connect param at 0 of normalize of cast to " + type + " with result of type " + res->getReturnType ( ) + "." );
			if ( ! normalized->eval ( ) )
				throw exception::CommonException ( "Eval of normalize of cast to " + type + " failed." );

			res = normalized;
		}

		return res;
	}

};

} /* namespace cli */

#endif /* _CAST_PARAM_H_ */
