#ifndef _CLI_FILE_STATEMENT_H_
#define _CLI_FILE_STATEMENT_H_

#include <ast/Statement.h>
#include <abstraction/Registry.h>

namespace cli {

class FileStatement final : public Statement {
	std::unique_ptr < cli::Arg > m_file;

public:
	FileStatement ( std::unique_ptr < Arg > file ) : m_file ( std::move ( file ) ) {
	}

	virtual std::shared_ptr < abstraction::OperationAbstraction > translateAndEval ( const std::shared_ptr < abstraction::OperationAbstraction > &, Environment & environment ) const override {
		ext::deque < sax::Token > tokens = sax::FromXMLParserHelper::parseInput ( m_file->eval ( environment ) );
		std::string type = tokens [ 0 ].getData ( );
		return abstraction::Registry::getXmlParserAbstraction ( type, tokens );
	}
};

} /* namespace cli */

#endif /* _CLI_BINDED_FILE_STATEMENT_H_ */
