/*
 * ReadFile.cpp
 *
 *  Created on: 21. 8. 2017
 *	  Author: Jan Travnicek
 */

#include "ReadFile.h"
#include <registration/AlgoRegistration.hpp>
#include <fstream>
#include <streambuf>

namespace cli {

namespace builtin {

std::string ReadFile::read ( const std::string & data ) {
	std::ifstream t ( data );
	return std::string ( ( std::istreambuf_iterator < char > ( t ) ), std::istreambuf_iterator < char > ( ) );
}

auto ReadFileString = registration::AbstractRegister < ReadFile, std::string, const std::string & > ( ReadFile::read );

} /* namespace builtin */

} /* namespace cli */

