#ifndef _CLI_NAME_INTROSPECTION_COMMAND_H_
#define _CLI_NAME_INTROSPECTION_COMMAND_H_

#include <command/Command.h>
#include <environment/Environment.h>

namespace cli {

class NamesIntrospectionCommand : public Command {
public:
	void printNames ( const ext::set < ext::pair < std::string, ext::set < std::string > > > & names ) const {
		for ( const std::pair < std::string, std::set < std::string > > & entry : names ) {
			std::cout << entry.first << " : ";
			bool first = true;
			for ( const std::string & name : entry.second ) {
				if ( first )
					first = false;
				else
					std::cout << ", ";

				std::cout << name;
			}
			std::cout << std::endl;
		}
	}

	virtual Command::Result run ( Environment & ) const override {
		printNames ( abstraction::Registry::listNames ( ) );
		return Command::Result::OK;
	}
};

} /* namespace cli */

#endif /* _CLI_NAME_INTROSPECTION_COMMAND_H_ */
