#ifndef _CLI_OVERLOADS_INTROSPECTION_COMMAND_H_
#define _CLI_OVERLOADS_INTROSPECTION_COMMAND_H_

#include <command/Command.h>
#include <environment/Environment.h>

namespace cli {

class OverloadsIntrospectionCommand : public Command {
	std::unique_ptr < cli::Arg > m_param;

public:
	OverloadsIntrospectionCommand ( std::unique_ptr < cli::Arg > param ) : m_param ( std::move ( param ) ) {
	}

	virtual Command::Result run ( Environment & environment ) const override {
		std::string param = m_param->eval ( environment );

		ext::set < ext::pair < ext::pair < std::string, ext::set < abstraction::ParamQualifiers::ParamQualifier > >, ext::vector < ext::tuple < std::string, ext::set < abstraction::ParamQualifiers::ParamQualifier >, std::string > > > > overloads = abstraction::Registry::listOverloads ( param );
		for ( const ext::pair < ext::pair < std::string, ext::set < abstraction::ParamQualifiers::ParamQualifier > >, ext::vector < ext::tuple < std::string, ext::set < abstraction::ParamQualifiers::ParamQualifier >, std::string > > > & overload : overloads ) {
			{
				const ext::pair < std::string, ext::set < abstraction::ParamQualifiers::ParamQualifier > > & result = overload.first;

				if ( std::get < 1 > ( result ).count ( abstraction::ParamQualifiers::ParamQualifier::CONST ) )
					std::cout << "const ";

				std::cout << std::get < 0 > ( result );

				if ( std::get < 1 > ( result ).count ( abstraction::ParamQualifiers::ParamQualifier::LREF ) )
					std::cout << " &";

				if ( std::get < 1 > ( result ).count ( abstraction::ParamQualifiers::ParamQualifier::RREF ) )
					std::cout << " &&";
			}
			std::cout << " (";
			bool first = true;
			for ( const ext::tuple < std::string, ext::set < abstraction::ParamQualifiers::ParamQualifier >, std::string > & parameter : overload.second ) {
				if ( first )
					first = false;
				else
					std::cout << ",";

				if ( std::get < 1 > ( parameter ).count ( abstraction::ParamQualifiers::ParamQualifier::CONST ) )
					std::cout << " const";
				else
					std::cout << " ";

				std::cout << std::get < 0 > ( parameter );

				if ( std::get < 1 > ( parameter ).count ( abstraction::ParamQualifiers::ParamQualifier::LREF ) )
					std::cout << " &";

				if ( std::get < 1 > ( parameter ).count ( abstraction::ParamQualifiers::ParamQualifier::RREF ) )
					std::cout << " &&";

				std::cout << " " << std::get < 2 > ( parameter );
			}
			std::cout << " )" << std::endl;
		}

		return Command::Result::OK;
	}
};

} /* namespace cli */

#endif /* _CLI_OVERLOADS_INTROSPECTION_COMMAND_H_ */
