/*
 * DowncastRegistry.cpp
 *
 *  Created on: 21. 8. 2017
 *	  Author: Jan Travnicek
 */

#include <abstraction/DowncastRegistry.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > DowncastRegistry::getAbstraction ( const std::string & concrete, const std::string & base ) {
	auto res = getEntries ( ).find ( std::make_pair ( concrete, base ) );
	if ( res == getEntries ( ).end ( ) )
		throw exception::CommonException ( "Entry " + concrete + ", " + base + " not available." );

	return res->second->getAbstraction ( );
}

} /* namespace abstraction */
