/*
 * ValuePrinterAbstraction.hpp
 *
 *  Created on: 11. 7. 2017
 *	  Author: Jan Travnicek
 */

#ifndef _VALUE_PRINTER_ABSTRACTION_HPP_
#define _VALUE_PRINTER_ABSTRACTION_HPP_

#include <abstraction/UnaryOperationAbstraction.hpp>
#include <abstraction/NullaryOperationAbstraction.hpp>
#include <tuple>

namespace abstraction {

template < class ParamType >
class ValuePrinterAbstraction : public UnaryOperationAbstraction < void, ParamType > {
public:
	virtual bool run ( ) override {
		if ( ! this->inputsReady ( ) )
			return false;

		std::cout << std::get < 0 > ( this->m_params )->getConstValueReference ( ) << std::endl;
		return true;
	}
};

template < >
class ValuePrinterAbstraction < void > : public NullaryOperationAbstraction < void > {
public:
	virtual bool run ( ) override {
		return true;
	}
};

} /* namespace abstraction */

#endif /* _VALUE_PRINTER_ABSTRACTION_HPP_ */
