/*
 * ValuePrinterRegistry.cpp
 *
 *  Created on: 21. 7. 2017
 *	  Author: Jan Travnicek
 */

#include <abstraction/ValuePrinterRegistry.hpp>

namespace abstraction {

std::shared_ptr < abstraction::OperationAbstraction > ValuePrinterRegistry::getAbstraction ( const std::string & param ) {
	auto res = getEntries ( ).find ( param );
	if ( res == getEntries ( ).end ( ) )
		throw exception::CommonException ( "Entry " + param + " not available." );

	return res->second->getAbstraction ( );
}

template < >
std::shared_ptr < abstraction::OperationAbstraction > ValuePrinterRegistry::EntryImpl < void >::getAbstraction ( ) const {
	return std::make_shared < abstraction::ValuePrinterAbstraction < void > > ( );
}

} /* namespace abstraction */
