#include <stdio.h>
#include <execinfo.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>

#include "sigHandler.h"

#include "simpleStacktrace.h"
#include <iostream>

namespace ext {

void SigHandler::handler(int signal) {
	switch(signal) {
		case SIGSEGV:
			std::cout << "Segmentation fault" << std::endl;
			break;
		case SIGINT:
			std::cout << "Interrupted" << std::endl;
			break;
		default:
			std::cout << "Unknown signal" << std::endl;
			break;
	}
	#ifdef DEBUG
		std::cout << ext::simpleStacktrace() << std::endl;
	#endif
	exit(1);
}

SigHandler::SigHandler() {
	signal(SIGSEGV, SigHandler::handler);
	signal(SIGINT, SigHandler::handler);
}

SigHandler SigHandler::HANDLER;

} /* namespace ext */
