/*
 * CompactNFA.cpp
 *
 *  Created on: Mar 25, 2013
 *      Author: Jan Travnicek
 */

#include "CompactNFA.h"
#include "../Automaton.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto compactNFAType = registration::TypeRegister < automaton::Automaton, automaton::CompactNFA < > > ( );
auto compactNFAType2 = registration::TypeRegister < alib::Object, automaton::CompactNFA < > > ( );

auto CompactNFAFromDFA = registration::CastRegister < automaton::CompactNFA < >, automaton::DFA < > > ( );
auto CompactNFAFromNFA = registration::CastRegister < automaton::CompactNFA < >, automaton::NFA < > > ( );
auto CompactNFAFromMultiInitialStateNFA = registration::CastRegister < automaton::CompactNFA < >, automaton::MultiInitialStateNFA < > > ( );
auto CompactNFAEpsilonNFA = registration::CastRegister < automaton::CompactNFA < >, automaton::EpsilonNFA < > > ( );

auto CompactNFAName = registration::NameRegister < automaton::CompactNFA < > > ( automaton::CompactNFA < >::getXmlTagName ( ) );

} /* namespace alib */
