/*
 * MultiInitialStateNFA.cpp
 *
 *  Created on: Mar 25, 2013
 *      Author: Jan Travnicek
 */

#include "MultiInitialStateNFA.h"
#include "../Automaton.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto multiInitialStateNFAType = registration::TypeRegister < automaton::Automaton, automaton::MultiInitialStateNFA < > > ( );
auto multiInitialStateNFAType2 = registration::TypeRegister < alib::Object, automaton::MultiInitialStateNFA < > > ( );

auto MultiInitialStateNFAFromDFA = registration::CastRegister < automaton::MultiInitialStateNFA < >, automaton::DFA < > > ( );
auto MultiInitialStateNFAFromNFA = registration::CastRegister < automaton::MultiInitialStateNFA < >, automaton::NFA < > > ( );

auto MultiInitialStateNFAName = registration::NameRegister < automaton::MultiInitialStateNFA < > > ( automaton::MultiInitialStateNFA < >::getXmlTagName ( ) );

} /* namespace alib */
