/*
 * String.cpp
 *
 *  Created on: Apr 16, 2013
 *      Author: Jan Travnicek
 */

#include "String.h"
#include "LinearString.h"
#include "CyclicString.h"
#include "Epsilon.h"
#include <core/xmlApi.hpp>

namespace string {

string::String stringFrom ( const DefaultSymbolType & symbol ) {
	return string::String { string::LinearString < > { ext::vector < DefaultSymbolType > { symbol } } };
}

string::String stringFrom ( const std::string & string ) {
	return string::String { string::LinearString < > { string } };
}

string::String stringFrom ( const char * string ) {
	return stringFrom ( ( std::string ) string );
}

string::String stringFrom ( const ext::vector < DefaultSymbolType > & str ) {
	return string::String { string::LinearString < > { str } };
}

} /* namespace string */
