/*
 * RankedTree.cpp
 *
 *  Created on: Nov 23, 2013
 *      Author: Stepan Plachy
 */

#include "RankedTree.h"
#include "../Tree.h"
#include "../RankedTreeWrapper.h"
#include <object/Object.h>
#include <registration/TypeRegistration.hpp>
#include <registration/CastRegistration.hpp>
#include <registration/NameRegistration.hpp>

namespace alib {

auto rankedTreeType = registration::TypeRegister < tree::Tree, tree::RankedTree < > > ( );
auto rankedTreeType2 = registration::TypeRegister < tree::RankedTreeWrapper, tree::RankedTree < > > ( );
auto rankedTreeType3 = registration::TypeRegister < alib::Object, tree::RankedTree < > > ( );

auto RankedTreeFromUnrankedTree = registration::CastRegister < tree::RankedTree < >, tree::UnrankedTree < > > ( );
auto RankedTreeFromPostfixRankedTree = registration::CastRegister < tree::RankedTree < >, tree::PostfixRankedTree < > > ( );

auto RankedTreeName = registration::NameRegister < tree::RankedTree < > > ( tree::RankedTree < >::getXmlTagName ( ) );

} /* namespace alib */
