/*
 * GraphTypes.h
 *
 *  Created on: Mar 16, 2016
 *      Author: Jan Broz
 */

#ifndef GRAPH_TYPES_H_
#define GRAPH_TYPES_H_

#include <string>

namespace graph {

enum class GRAPH_TYPE {
	UNDIRECTED,
	DIRECTED
};
std::string typeToString( GRAPH_TYPE t );
GRAPH_TYPE typeFromString( const std::string & str );

// !! add graph types/representations
enum class REPRESENTATION {
	ADJACENCY_LIST,
	ADJACENCY_MATRIX,
	INCIDENCE_MATRIX
};
std::string representationToString( REPRESENTATION r );
REPRESENTATION representationFromString( const std::string & str );

} // namespace graph

#endif // GRAPH_TYPES_H_
