/*
 * EpsilonRemoverIncoming.cpp
 *
 *  Created on: 24. 11. 2014
 *	  Author: Jan Travnicek
 */

#include "EpsilonRemoverIncoming.h"
#include <registration/AlgoRegistration.hpp>

namespace automaton {

namespace simplify {

namespace efficient {

auto EpsilonRemoverIncomingDFA = registration::OverloadRegister < EpsilonRemoverIncoming, automaton::DFA < >, automaton::DFA < > > ( EpsilonRemoverIncoming::remove );
auto EpsilonRemoverIncomingMultiInitialStateNFA = registration::OverloadRegister < EpsilonRemoverIncoming, automaton::MultiInitialStateNFA < >, automaton::MultiInitialStateNFA < > > ( EpsilonRemoverIncoming::remove );
auto EpsilonRemoverIncomingNFA = registration::OverloadRegister < EpsilonRemoverIncoming, automaton::NFA < > , automaton::NFA < > > ( EpsilonRemoverIncoming::remove );
auto EpsilonRemoverIncomingEpsilonNFA = registration::OverloadRegister < EpsilonRemoverIncoming, automaton::NFA < > , automaton::EpsilonNFA < > > ( EpsilonRemoverIncoming::remove );

automaton::Automaton EpsilonRemoverIncoming::remove ( const automaton::Automaton& automaton ) {
	return dispatch ( automaton.getData ( ) );
}

} /* namespace efficient */

} /* namespace simplify */

} /* namespace automaton */
