/*
 * AutomatonFromStringLexer.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef AUTOMATON_FROM_STRING_LEXER_H_
#define AUTOMATON_FROM_STRING_LEXER_H_

#include <string>
#include <istream>

namespace automaton {

class AutomatonFromStringLexer {
public:
	enum class TokenType {
		EPSILON_NFA,
		MULTI_INITIAL_STATE_NFA,
		NFA,
		DFA,
		OUT,
		IN,
		EPSILON,
		SEPARATOR,
		NONE,
		NEW_LINE,
		TEOF,
		ERROR
	};

	struct Token {
		TokenType type;
		std::string value;
		std::string raw;
	};

	static Token next(std::istream& input);
	static void putback(std::istream&, Token token);
};

} /* namepsace automaton */

#endif /* AUTOMATON_FROM_STRING_LEXER_H_ */
