/*
 * RegExpFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef REG_EXP_FROM_STRING_PARSER_H_
#define REG_EXP_FROM_STRING_PARSER_H_

#include "regexp/RegExpFeatures.h"
#include "RegExpFromStringLexer.h"

#include <set>
#include <memory>
#include <utility>

namespace regexp {

class RegExpFromStringParser {
	static ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > alternation(std::istream& input);
	static ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > alternationCont(std::istream& input, ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > left);
	static ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > alternationContCont(std::istream& input, UnboundedRegExpAlternation < DefaultSymbolType > left);

	static ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > concatenation(std::istream& input);
	static ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > concatenationCont(std::istream& input, ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > left);
	static ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > concatenationContCont(std::istream& input, UnboundedRegExpConcatenation < DefaultSymbolType > left);

	static ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > factor(std::istream& input);
	static ext::rvalue_ref < UnboundedRegExpElement < DefaultSymbolType > > star(std::istream& input, UnboundedRegExpElement < DefaultSymbolType > && elem);

public:
	static UnboundedRegExpStructure < DefaultSymbolType > parseUnboundedRegExpStructure(std::istream& input);
	static RegExp parseRegExp(std::istream& input);
	static RegExp parseRegExp(std::istream& input, const ext::set<FEATURES>& features);
};

} /* namespace regexp */

#endif /* REG_EXP_FROM_STRING_PARSER_H_ */
