/*
 * StringFromStringParser.h
 *
 *  Created on: Nov 23, 2013
 *      Author: Jan Travnicek
 */

#ifndef STRING_FROM_STRING_PARSER_H_
#define STRING_FROM_STRING_PARSER_H_

#include "string/StringFeatures.h"
#include "StringFromStringLexer.h"

#include <set>
#include <vector>

#include "alphabet/Symbol.h"

namespace string {

class StringFromStringParser {
	static ext::vector<DefaultSymbolType> parseContent(std::istream&);

public:
	static String parseString(std::istream&);
	static String parseString(std::istream&, const ext::set<FEATURES>& features);

};

} /* namespace string */

#endif /* STRING_FROM_STRING_PARSER_H_ */
