#include "SymbolTest.h"

#include "object/Object.h"

#include "factory/StringDataFactory.hpp"

CPPUNIT_TEST_SUITE_NAMED_REGISTRATION( SymbolTest, "alphabet" );
CPPUNIT_TEST_SUITE_REGISTRATION( SymbolTest );

void SymbolTest::setUp() {
}

void SymbolTest::tearDown() {
}

void SymbolTest::testEqual() {
	{
		std::string input = "a";
		alib::Object symbol = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(symbol);

		CPPUNIT_ASSERT( input == output );

		alib::Object symbol2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( symbol == symbol2 );
	}
	{
		std::string input = "aaaa";
		alib::Object symbol = alib::StringDataFactory::fromString (input);

		std::string output = alib::StringDataFactory::toString(symbol);

		CPPUNIT_ASSERT( input == output );

		alib::Object symbol2 = alib::StringDataFactory::fromString (output);

		CPPUNIT_ASSERT( symbol == symbol2 );
	}
}

